/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package aco;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.LinkedList;
import java.util.List;
import java.util.Map.Entry;
import java.util.Random;

import org.cloudbus.cloudsim.Cloudlet;
import org.cloudbus.cloudsim.CloudletSchedulerDynamicWorkload;
import org.cloudbus.cloudsim.DatacenterBroker;
import org.cloudbus.cloudsim.DatacenterCharacteristics;
import org.cloudbus.cloudsim.HostStateHistoryEntry;
import org.cloudbus.cloudsim.Log;
import org.cloudbus.cloudsim.Pe;
import org.cloudbus.cloudsim.Storage;
import org.cloudbus.cloudsim.UtilizationModelStochastic;
import org.cloudbus.cloudsim.Vm;
import org.cloudbus.cloudsim.VmSchedulerTimeShared;
import org.cloudbus.cloudsim.core.CloudSim;
import org.cloudbus.cloudsim.power.PowerDatacenter;
import org.cloudbus.cloudsim.power.PowerHost;
import org.cloudbus.cloudsim.power.models.PowerModelLinear;
import org.cloudbus.cloudsim.provisioners.BwProvisionerSimple;
import org.cloudbus.cloudsim.provisioners.PeProvisionerSimple;
import org.cloudbus.cloudsim.provisioners.RamProvisionerSimple;
import org.cloudbus.cloudsim.power.PowerVmAllocationPolicyMigrationAbstract;
import org.cloudbus.cloudsim.power.PowerVmAllocationPolicyMigrationInterQuartileRange;
import org.cloudbus.cloudsim.power.PowerVmAllocationPolicyMigrationLocalRegression;
import org.cloudbus.cloudsim.power.PowerVmAllocationPolicyMigrationLocalRegressionRobust;
import org.cloudbus.cloudsim.power.PowerVmAllocationPolicyMigrationMedianAbsoluteDeviation;
import org.cloudbus.cloudsim.power.PowerVmAllocationPolicyMigrationStaticThreshold;
import org.cloudbus.cloudsim.power.PowerVmAllocationPolicySimple;
import org.cloudbus.cloudsim.power.PowerVmSelectionPolicy;
import org.cloudbus.cloudsim.power.PowerVmSelectionPolicyMaximumCorrelation;
import org.cloudbus.cloudsim.power.PowerVmSelectionPolicyMinimumMigrationTime;
import org.cloudbus.cloudsim.power.PowerVmSelectionPolicyMinimumUtilization;
import org.cloudbus.cloudsim.power.PowerVmSelectionPolicyRandomSelection;

/**
 *
 * 
 */
public class ACO {

     private static List<Cloudlet> cloudletList;

	private static List<Vm> vmList;

	public static void main(String[] args)
        {
               invert_ant_alghorithm();
		
	}
        
 //-------------------------invert ant clony-----------------------
        private static double hostsNumber = 10;
	private static int vmsNumber = 10;
	private static int cloudletsNumber = 10;
        static int[][] ant=new int[10][2];
        static int[][] ant_path=new int[10][10];
        static double[][] pher_edge=new double[10][10];
       
        static double dep_phr=0.009;
        static double[] cost_ant=new double[10000];
        static int ant_count=0;
        static int[] check=new int[10];
        static int max_ttl=5;
        static double edge_max_speed=1;
        static int[] cloudlet_vm=new int[10];
        private static void initial(){
            Random x = new Random();
            int k=0,count=0;
            while(true)
              {
                  if(count==10)
                      break;
                k=x.nextInt(vmsNumber);      
                if(check[k]==0)
                {
                  ant_path[count][k]=1;
                  ant_count++;
                  ant[count][0]=count;
                  ant[count][1]=k;
                  check[count]=1;
                  count++;
                }
              }
            for(int i=0;i<ant_count;i++)
              {
                    for(int j=0;j<vmsNumber;j++)
                       pher_edge[i][j]=dep_phr;
               }    
          }
        
        private static void invert_ant_alghorithm() {
            initial();
            int step=0;
            double MIN_TTL;
            while(step<max_ttl)
            {
                for(int i=0;i<ant_count;i++)
               {
                MIN_TTL=cost(i)/edge_max_speed;
                pher_edge[i][ant[i][1]]=pher_edge[i][ant[i][1]]+dep_phr;
                pher_edge[i][ant[i][1]]=pher_edge[i][ant[i][1]]-MIN_TTL*dep_phr;
              }
                for(int i=0;i<ant_count;i++)
                    next_step(i);
              step++;
            }
            best_ant_phermon();
        }
        
        private static void best_ant_phermon()
        {
             for(int i=0;i<ant_count;i++)
              {
                  double temp=-100;
                  int index=0;
                    for(int j=0;j<vmsNumber;j++)
                        if(temp<pher_edge[i][j])
                        {
                          temp=pher_edge[i][j];
                          index=j;
                        }
                    cloudlet_vm[i]=index;
                    for(int j=0;j<ant_count;j++)
                        pher_edge[j][index]=-100;
               }    
         //    for(int i=0;i<cloudletsNumber;i++)
             Log.printLine(String.format("\n"));
             Log.printLine(String.format("\n"));
             Log.printLine(String.format("\n--------------------------------------------------------\n"));
                final_cost();
             
         
        }
         private static void next_step(int i) {
              Random x = new Random();
              int k=0,flag=0;
              for(int i1=0;i1<vmsNumber;i1++)
                  if(ant_path[i][i1]==0)
                      flag=1;
              if(flag==1)
             {
             while(true)
              {
                k=x.nextInt(vmsNumber);      
                if(ant_path[i][k]==0)
                {
                  ant_path[i][k]=1;
                  ant[i][1]=k;
                  break;
                }
              }
             }
             
         }
        
        
      
   //--------------------------- Cost ---------------------------------------------
    
        private static void final_cost(){
             try {
                 
			int num_user = 1; 
			Calendar calendar = Calendar.getInstance();
			boolean trace_flag = false; 

			create_task();
			CloudSim.init(num_user, calendar, trace_flag);

			PowerDatacenter datacenter = createDatacenter("Datacenter_0");

			DatacenterBroker broker = createBroker();
			int brokerId = broker.getId();

			vmList = createVms(brokerId);

			broker.submitVmList(vmList);

			cloudletList = createCloudletList1(brokerId);

			broker.submitCloudletList(cloudletList);

			double lastClock = CloudSim.startSimulation();

			List<Cloudlet> newList = broker.getCloudletReceivedList();
			

			CloudSim.stopSimulation();

			printCloudletList(newList);

		 int totalTotalRequested = 0;
double totalTotalAllocated = 0;
int numberOfAllocations = 0;
double  alloc;
int count=0;
for(PowerHost h : datacenter.<PowerHost>getHostList()) { // Get every host
    numberOfAllocations=0;
     double totalAllocated = 0;
    for (HostStateHistoryEntry entry : h.getStateHistory()) 
    { // Get host state history
            alloc = entry.getAllocatedMips();
            numberOfAllocations++;
            totalAllocated += alloc;
    }
            totalTotalAllocated += totalAllocated/numberOfAllocations;
   }
		    
 
			Log.printLine();
			Log.printLine(String.format("Total execution time: %.2f sec", lastClock));
			Log.printLine(String.format("Energy consumption: %.2f kWh", datacenter.getPower() / (3600 * 1000)));
                        Log.printLine(String.format("total allocated (SLA): %.2f",totalTotalAllocated));
			
			Log.printLine();
                        
		} catch (Exception e) {
			//e.printStackTrace();
			//Log.printLine("errors happen");
		}
           }
       
        private static double cost(int AID){
             try {
                 
			int num_user = 1; 
			Calendar calendar = Calendar.getInstance();
			boolean trace_flag = false; 

			create_task();
			CloudSim.init(num_user, calendar, trace_flag);

			PowerDatacenter datacenter = createDatacenter("Datacenter_0");

			DatacenterBroker broker = createBroker();
			int brokerId = broker.getId();

			vmList = createVms(brokerId);

			broker.submitVmList(vmList);

			cloudletList = createCloudletList(brokerId,AID);

			broker.submitCloudletList(cloudletList);

			double lastClock = CloudSim.startSimulation();

			List<Cloudlet> newList = broker.getCloudletReceivedList();
			

			CloudSim.stopSimulation();

			//printCloudletList(newList);

		      

		
                        return datacenter.getPower() / (3600 * 1000);
		} catch (Exception e) {
		
		}
             return 1000000;
             
        }
        
	private static List<Cloudlet> createCloudletList(int brokerId,int ant_id) {
		List<Cloudlet> list = new ArrayList<Cloudlet>();
                        int pesNumber=1;       
                        Cloudlet cloudlet = new Cloudlet(ant_id,length_task[ant_id], pesNumber, fileSize_task[ant_id], outputSize_task[ant_id], new UtilizationModelStochastic(), new UtilizationModelStochastic(), new UtilizationModelStochastic());
                    	cloudlet.setUserId(brokerId);
			cloudlet.setVmId(ant[ant_id][1]);
			list.add(cloudlet);
            	return list;
	}
        
        private static List<Cloudlet> createCloudletList1(int brokerId) {
		List<Cloudlet> list = new ArrayList<Cloudlet>();
                        int pesNumber=1;       
                        for (int i = 0; i < cloudletsNumber; i++)
                        {
                Cloudlet cloudlet = new Cloudlet(i,length_task[i], pesNumber, fileSize_task[i], outputSize_task[i], new UtilizationModelStochastic(), new UtilizationModelStochastic(), new UtilizationModelStochastic());
                    	cloudlet.setUserId(brokerId);
			cloudlet.setVmId(cloudlet_vm[i]);
			list.add(cloudlet);
                        }
                        
            	return list;
	}

	static long[] length_task=new long[10];
	static long[] fileSize_task = new long[10];
	static long[] outputSize_task = new long[10];
        
        private static void create_task() {
		length_task[0] = 550000; 
                length_task[1] = 500000; 
                length_task[2] = 450000; 
                length_task[3] = 400000; 
                length_task[4] = 350000; 
                length_task[5] = 300000; 
                length_task[6] = 250000; 
                length_task[7] = 200000; 
                length_task[8] = 150000; 
                length_task[9] = 100000; 
//------------------------------------------------------------------------------		
		fileSize_task[0] = 400; 
                fileSize_task[1] = 350; 
                fileSize_task[2] = 300; 
                fileSize_task[3] = 200; 
                fileSize_task[4] = 450; 
                fileSize_task[5] = 400; 
                fileSize_task[6] = 350; 
                fileSize_task[7] = 300; 
                fileSize_task[8] = 200; 
                fileSize_task[9] = 100; 
//------------------------------------------------------------------------------                
                outputSize_task[0] = 650; 
                outputSize_task[1] = 600; 
                outputSize_task[2] = 550; 
                outputSize_task[3] = 500; 
                outputSize_task[4] = 450; 
                outputSize_task[5] = 400; 
                outputSize_task[6] = 350; 
                outputSize_task[7] = 300; 
                outputSize_task[8] = 250; 
                outputSize_task[9] = 200; 
	}
        
        private static List<Vm> createVms(int brokerId) {
		List<Vm> vms = new ArrayList<Vm>();

		int[] mips = { 250, 500, 750, 1000 }; 
		int pesNumber = 1;
		int ram = 128; 
		long bw = 2500; 
		long size = 2500;
		String vmm = "Xen";
                int i=0;
		
                i=0;
			vms.add(
				new Vm(i, brokerId, mips[i % mips.length], pesNumber, ram, bw, size, vmm, new CloudletSchedulerDynamicWorkload(mips[i % mips.length], pesNumber))
			);
		
                int[]  mips1 = { 100, 200, 400,300 }; 
		 pesNumber = 1;
		 ram = 128; 
		 bw = 200; 
		size = 2500;
		vmm = "Xen";
                 i=1;
			vms.add(
				new Vm(i, brokerId, mips1[i % mips1.length], pesNumber, ram, bw, size, vmm, new CloudletSchedulerDynamicWorkload(mips1[i % mips1.length], pesNumber))
			);
	
                 int[]  mips2 = { 250, 250, 500,350 }; 
		 pesNumber = 1;
		 ram = 500; 
		 bw = 250; 
		size = 2000;
		vmm = "Xen";
                i=2;
	
			vms.add(
				new Vm(i, brokerId, mips2[i % mips2.length], pesNumber, ram, bw, size, vmm, new CloudletSchedulerDynamicWorkload(mips2[i % mips2.length], pesNumber))
			);
	
                 int[]  mips3 = { 150, 300, 450,600 }; 
		 pesNumber = 1;
		 ram = 400; 
		 bw = 250; 
		size = 3500;
		vmm = "Xen";
                 i=3;
	         	vms.add(
				new Vm(i, brokerId, mips3[i % mips3.length], pesNumber, ram, bw, size, vmm, new CloudletSchedulerDynamicWorkload(mips3[i % mips3.length], pesNumber))
			);
		
                 int[]  mips4 = { 150, 300, 500,400 }; 
		 pesNumber = 1;
		 ram = 500; 
		 bw = 300; 
		size = 4000;
		vmm = "Xen";
                i=4;
			vms.add(
				new Vm(i, brokerId, mips4[i % mips4.length], pesNumber, ram, bw, size, vmm, new CloudletSchedulerDynamicWorkload(mips4[i % mips4.length], pesNumber))
			);
		
                 int[]  mips5 = { 100, 300, 400,500 }; 
		 pesNumber = 1;
		 ram = 256; 
		 bw = 400; 
		size = 3000;
		vmm = "Xen";
                i=5;
			vms.add(
				new Vm(i, brokerId, mips5[i % mips5.length], pesNumber, ram, bw, size, vmm, new CloudletSchedulerDynamicWorkload(mips5[i % mips5.length], pesNumber))
			);

                 int[]  mips6 = { 300, 600, 500,400 }; 
		 pesNumber = 1;
		 ram = 500; 
		 bw = 250; 
		size = 3000;
		vmm = "Xen";
                i=6;
			vms.add(
				new Vm(i, brokerId, mips6[i % mips6.length], pesNumber, ram, bw, size, vmm, new CloudletSchedulerDynamicWorkload(mips6[i % mips6.length], pesNumber))
			);
		
                 int[]  mips7 = { 250, 250, 650,550 }; 
		 pesNumber = 1;
		 ram = 500; 
		 bw = 250; 
		size = 3000;
		vmm = "Xen";
                i=7;
			vms.add(
				new Vm(i, brokerId, mips7[i % mips7.length], pesNumber, ram, bw, size, vmm, new CloudletSchedulerDynamicWorkload(mips7[i % mips7.length], pesNumber))
			);
		
                 int[]  mips8 = { 100, 150, 500,400 }; 
		 pesNumber = 1;
		 ram = 256; 
		 bw = 300; 
		size = 3000;
		vmm = "Xen";
                i=8;
			vms.add(
				new Vm(i, brokerId, mips8[i % mips8.length], pesNumber, ram, bw, size, vmm, new CloudletSchedulerDynamicWorkload(mips8[i % mips8.length], pesNumber))
			);
		
                 int[]  mips9 = { 100, 200, 400,500 }; 
		 pesNumber = 1;
		 ram = 256; 
		 bw = 500; 
		size = 3500;
		vmm = "Xen";
                i=9;
			vms.add(
				new Vm(i, brokerId, mips9[i % mips9.length], pesNumber, ram, bw, size, vmm, new CloudletSchedulerDynamicWorkload(mips9[i % mips9.length], pesNumber))
			);
		return vms;
	}
        
	private static PowerDatacenter createDatacenter(String name) throws Exception {
		List<PowerHost> hostList = new ArrayList<PowerHost>();

		double maxPower = 250; 
		double staticPowerPercent = 0.7; 

		int[] mips = { 1000, 2000, 3000 };
		int ram = 10000; 
		long storage = 1000000;
		int bw = 100000;

		for (int i = 0; i < hostsNumber; i++) {
			
			List<Pe> peList = new ArrayList<Pe>();
			peList.add(new Pe(0, new PeProvisionerSimple(mips[i % mips.length]))); 

			hostList.add(
				new PowerHost(
					i,
					new RamProvisionerSimple(ram),
					new BwProvisionerSimple(bw),
					storage,
					peList,
                                         
					new VmSchedulerTimeShared(peList), 
					new PowerModelLinear(maxPower, staticPowerPercent)
				)
			); 
		}

		String arch = "x86"; 
		String os = "Linux"; 
		String vmm = "Xen";
		double time_zone = 10.0;
		double cost = 3.0; 
		double costPerMem = 0.05;
		double costPerStorage = 0.001;
						
		double costPerBw = 0.0; 

		DatacenterCharacteristics characteristics = new DatacenterCharacteristics(
				arch, os, vmm, hostList, time_zone, cost, costPerMem, costPerStorage, costPerBw);

		
		PowerDatacenter powerDatacenter = null;
		try {
                    
			powerDatacenter = new PowerDatacenter(
					name,
					characteristics,
					new PowerVmAllocationPolicySimple(hostList),
					new LinkedList<Storage>(),
					5.0);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return powerDatacenter;
	}

	private static DatacenterBroker createBroker() {
		DatacenterBroker broker = null;
		try {
			broker = new DatacenterBroker("Broker");
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		return broker;
	}
        
	private static void printCloudletList(List<Cloudlet> list) {
		int size = list.size();
		Cloudlet cloudlet;

		String indent = "\t";
		Log.printLine();
		Log.printLine("========== OUTPUT ==========");
		Log.printLine("Cloudlet ID" + indent + "STATUS" + indent
				+ "Resource ID" + indent + "VM ID" + indent + "Time" + indent
				+ "Start Time" + indent + "Finish Time");

		DecimalFormat dft = new DecimalFormat("###.##");
		for (int i = 0; i < size; i++) {
			cloudlet = list.get(i);
			Log.print(indent + cloudlet.getCloudletId());

			if (cloudlet.getCloudletStatus() == Cloudlet.SUCCESS) {
				Log.printLine(indent + "SUCCESS"
					+ indent + indent + cloudlet.getResourceId()
					+ indent + cloudlet.getVmId()
					+ indent + dft.format(cloudlet.getActualCPUTime())
					+ indent + dft.format(cloudlet.getExecStartTime())
					+ indent + indent + dft.format(cloudlet.getFinishTime())
				);
			}
		}
	}
        
       
//------------------------------------------------------------------------------

}
